#!/bin/bash

source /usr/share/phytec-gstreamer-examples/func.sh

init_dev
[ $? -ne 0 ] && exit 1

guess_param

display_help() {
	echo "Usage: ./set-pipeline.sh -f <format> [-e <cam entity>] [-s <frame size>] [-o <offset>] [-c <sensor size>] [-v]"
}

OPTIONS="he:f:s:o:c:v"
CAM_NUM="${CAM_ENTITY_NUMBER}"
CAM_ENT="$(media-ctl -p | grep "entity ${CAM_NUM}" | sed 's/.*: \(.*\) (.*/\1/g')"
COLOR="$(v4l2-ctl -d ${CAM_SUB_DEVICE} --get-subdev-fmt 0 | grep "Mediabus Code" | sed 's/.*BUS_FMT_\([A-Z]*\).*/\1/g')"
if [ $COLOR = "Y" ]; then
	FMT="${CAM_BW_FMT}"
else
	FMT="${CAM_COL_FMT}"
fi
RES="$SENSOR_RES"
OFFSET="($OFFSET_SENSOR)"
FRES="$SENSOR_RES"
VERBOSE=""

while getopts $OPTIONS option
do
	case $option in
		e ) CAM_ENT=$OPTARG;;
		f ) FMT=$OPTARG;;
		s ) RES=$OPTARG;;
		o ) OFFSET=$OPTARG;;
		c ) FRES=$OPTARG;;
		v ) VERBOSE="-v";;
		h  ) display_help; exit;;
		\? ) echo "Unknown option: -$OPTARG" >&2; exit 1;;
		:  ) echo "Missing option argument for -$OPTARG" >&2; exit 1;;
		*  ) echo "Unimplemented option: -$OPTARG" >&2; exit 1;;
	esac
done

if [ -z "$CAM_ENT" ] || [ -z "$FMT" ] || [ -z "$RES" ] || [ -z "$OFFSET" ] || [ -z "$FRES" ]; then
	echo "Missing argument"
	display_help
	exit 1
fi

echo " Setting ${FMT}/${RES} ${OFFSET}/${FRES} for ${CAM_ENT}"


media-ctl -V "'${CAM_ENT}':0[fmt:${FMT}/${RES} ${OFFSET}/${FRES}]" ${VERBOSE}
media-ctl -V "'csi':1 [fmt:${FMT}/${RES} field:none]" ${VERBOSE}
